<template>
  <div v-if="!hasPermission" class="subscription-banner">
    <p>¡Suscríbete para recibir las últimas notificaciones!</p>
    <button class="button" @click="subscribeUser">Suscribirse</button>
  </div>
</template>

<script lang="ts">
import webPushService from '@/services/webPush/webPushService';
import utils from '@/global/utils';
import config from '@/config';

export default {
  name: 'subscription-button',
  data() {
    return {
      hasPermission: false
    }
  },
  created() {
    // Verificamos que tenemos permiso para enviar notificaciones previamente concedido
    if ('Notification' in window) {
      this.hasPermission = Notification.permission === 'granted';
    }
  },
  methods: {
    async requestPermission() {
      // Solicitamos permiso para enviar notificaciones
      if ('Notification' in window && 'PushManager' in window) {
        const permission = await Notification.requestPermission();
        console.log("🚀 ~ requestPermission ~ permission:", permission);
        this.hasPermission = permission === 'granted';
        return this.hasPermission;
      }
      return false;
    },
    async subscribeUser() {
      if (!this.hasPermission && !await this.requestPermission()) {
        alert('No tienes permiso para enviar notificaciones, revisa la configuración de sitios de tu navegador.');
        return;
      }

      if (!('serviceWorker' in navigator)) {
        alert('Tu navegador no soporta el servicio de notificaciones');
        return;
      }

      try {
        const registration = await navigator.serviceWorker.ready
          .then((res) => { console.log('Service Worker ready'); return res })
          .catch((err) => console.log('Service Worker not ready', err));

        // const registration = await navigator.serviceWorker.getRegistration();

        if (!registration) {
          alert("No hay registro de Service Worker.");
          return;
        }
        console.log("🚀 ~ subscribeUser ~ registration:", registration);
        const subscription = await registration.pushManager.subscribe({
          userVisibleOnly: true,
          applicationServerKey: utils.urlBase64ToUint8Array(config.publicVapidKey)
        });
        console.log("🚀 ~ subscribeUser ~ subscription:", subscription);

        // Envía esta suscripción al servidor backend para guardarla y usarla para enviar notificaciones.    
        await webPushService.subscribe(subscription);
        alert('Suscripción exitosa');
      } catch (error) {
        console.log("🚀 ~ subscribeUser ~ error:", error);
        alert('Error al suscribirse');
      }
    }
  }
}
</script>

<style scoped>
.subscription-banner {
  position: fixed;
  top: 0;
  left: 0;
  width: calc(100% - 20px);
  z-index: 999;
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: #f9f9f9;
  padding: 10px;
  border: 1px solid #ccc;
  border-radius: 5px;
  margin: 10px;
  box-sizing: border-box;
}

.subscription-banner p {
  margin: 0;
  font-size: 16px;
}

.button {
  padding: 10px 20px;
  border: none;
  border-radius: 5px;
  background-color: #ff9900;
  color: white;
  cursor: pointer;
  font-size: 16px;
  transition: background-color 0.3s;
}

.button:hover {
  background-color: #cc7700;
}
</style>
